From fd9a3a0216f3f509cd973e087944ae0ff7b46f13 Mon Sep 17 00:00:00 2001
From: FateJH <Jason_DiDonato@yahoo.com>
Date: Tue, 18 Jun 2019 14:43:26 -0400
Subject: [PATCH 09/31] commit before changes, and to switch gears momentarily;
 making charId somewhat native to Avatar and its converter, though not yet
 essential; protype for squad definition loadouts, even though no example of
 functionality exists; a lot of unimplemented work in preparation to convert
 SquadDetailDefinitionUpdateMessage from a static format to a variable-field
 format

---
 .../scala/net/psforever/objects/Avatar.scala  |  44 +-
 .../scala/net/psforever/objects/Player.scala  |   8 +-
 .../objects/avatar/LoadoutManager.scala       |  27 +
 .../converter/AvatarConverter.scala           |   2 +-
 .../objects/loadouts/EquipmentLoadout.scala   |  22 +
 .../objects/loadouts/InfantryLoadout.scala    |   2 +-
 .../psforever/objects/loadouts/Loadout.scala  |  49 +-
 .../objects/loadouts/SquadLoadout.scala       |  11 +
 .../objects/loadouts/VehicleLoadout.scala     |   2 +-
 .../terminals/OrderTerminalDefinition.scala   |   4 +-
 .../psforever/objects/teamwork/Member.scala   |   8 +
 .../game/SquadDefinitionActionMessage.scala   |   2 +-
 .../SquadDetailDefinitionUpdateMessage.scala  | 751 +++++++++++++++++-
 .../CharacterAppearanceData.scala             |   3 +-
 .../services/teamwork/SquadService.scala      |   7 +-
 ...uadDetailDefinitionUpdateMessageTest.scala |  15 +-
 .../game/objectcreate/CharacterDataTest.scala |   6 +-
 .../DetailedCharacterDataTest.scala           |  10 +-
 .../MountedVehiclesTest.scala                 |   2 +-
 .../src/test/scala/objects/AvatarTest.scala   |  32 +-
 .../objects/terminal/OrderTerminalTest.scala  |   4 +-
 .../src/main/scala/WorldSessionActor.scala    |  58 +-
 22 files changed, 938 insertions(+), 131 deletions(-)
 create mode 100644 common/src/main/scala/net/psforever/objects/avatar/LoadoutManager.scala
 create mode 100644 common/src/main/scala/net/psforever/objects/loadouts/EquipmentLoadout.scala
 create mode 100644 common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala

diff --git a/common/src/main/scala/net/psforever/objects/Avatar.scala b/common/src/main/scala/net/psforever/objects/Avatar.scala
index 1307ee58..01ce2d46 100644
--- a/common/src/main/scala/net/psforever/objects/Avatar.scala
+++ b/common/src/main/scala/net/psforever/objects/Avatar.scala
@@ -1,10 +1,9 @@
 // Copyright (c) 2017 PSForever
 package net.psforever.objects
 
-import net.psforever.objects.avatar.DeployableToolbox
+import net.psforever.objects.avatar.{DeployableToolbox, LoadoutManager}
 import net.psforever.objects.definition.{AvatarDefinition, ImplantDefinition}
 import net.psforever.objects.equipment.{EquipmentSize, EquipmentSlot}
-import net.psforever.objects.loadouts.Loadout
 import net.psforever.packet.game.objectcreate.Cosmetics
 import net.psforever.types._
 
@@ -12,6 +11,8 @@ import scala.annotation.tailrec
 import scala.collection.mutable
 
 class Avatar(val name : String, val faction : PlanetSideEmpire.Value, val sex : CharacterGender.Value, val head : Int, val voice : CharacterVoice.Value) {
+  /** Character ID; a unique identifier corresponding to a database table row index */
+  private var charId : Long = 0
   /** Battle Experience Points */
   private var bep : Long = 0
   /** Command Experience Points */
@@ -29,11 +30,15 @@ class Avatar(val name : String, val faction : PlanetSideEmpire.Value, val sex :
     * @see `DetailedCharacterData.implants`
     */
   private val implants : Array[ImplantSlot] = Array.fill[ImplantSlot](3)(new ImplantSlot)
-  /** Loadouts<br>
-    * 0-9 are Infantry loadouts
+  /** Equipment Loadouts<br>
+    * 0-9 are Infantry loadouts<br>
     * 10-14 are Vehicle loadouts
     */
-  private val loadouts : Array[Option[Loadout]] = Array.fill[Option[Loadout]](15)(None)
+  private val equipmentLoadouts : LoadoutManager = new LoadoutManager(15)
+  /**
+    * Squad Loadouts
+    */
+  private val squadLoadouts : LoadoutManager = new LoadoutManager(10)
   /** Locker */
   private val locker : LockerContainer = new LockerContainer() {
     override def toString : String = {
@@ -43,6 +48,15 @@ class Avatar(val name : String, val faction : PlanetSideEmpire.Value, val sex :
 
   private val deployables : DeployableToolbox = new DeployableToolbox
 
+  def CharId : Long = charId
+
+  def CharId_=(id : Long) : Long = {
+    if(charId == 0) { //does not need to be set but can only set once
+      charId = id
+    }
+    CharId
+  }
+
   def BEP : Long = bep
 
   def BEP_=(battleExperiencePoints : Long) : Long = {
@@ -164,25 +178,9 @@ class Avatar(val name : String, val faction : PlanetSideEmpire.Value, val sex :
     })
   }
 
-  def SaveLoadout(owner : Player, label : String, line : Int) : Unit = {
-    if(line > -1 && line < 10) {
-      loadouts(line) = Some(Loadout.Create(owner, label))
-    }
-  }
+  def EquipmentLoadouts : LoadoutManager = equipmentLoadouts
 
-  def SaveLoadout(owner : Vehicle, label : String, line : Int) : Unit = {
-    if(line > 9 && line < loadouts.length) {
-      loadouts(line) = Some(Loadout.Create(owner, label))
-    }
-  }
-
-  def LoadLoadout(line : Int) : Option[Loadout] = loadouts.lift(line).flatten
-
-  def DeleteLoadout(line : Int) : Unit = {
-    loadouts(line) = None
-  }
-
-  def Loadouts : Seq[(Int, Loadout)] = loadouts.zipWithIndex.collect { case(Some(loadout), index) => (index, loadout) } toSeq
+  def SquadLoadouts : LoadoutManager = squadLoadouts
 
   def Locker : LockerContainer = locker
 
diff --git a/common/src/main/scala/net/psforever/objects/Player.scala b/common/src/main/scala/net/psforever/objects/Player.scala
index e1e015f2..7577b545 100644
--- a/common/src/main/scala/net/psforever/objects/Player.scala
+++ b/common/src/main/scala/net/psforever/objects/Player.scala
@@ -1,10 +1,10 @@
 // Copyright (c) 2017 PSForever
 package net.psforever.objects
 
+import net.psforever.objects.avatar.LoadoutManager
 import net.psforever.objects.definition.{AvatarDefinition, ExoSuitDefinition, SpecialExoSuitDefinition}
 import net.psforever.objects.equipment.{Equipment, EquipmentSize, EquipmentSlot}
 import net.psforever.objects.inventory.{Container, GridInventory, InventoryItem}
-import net.psforever.objects.loadouts.Loadout
 import net.psforever.objects.serverobject.affinity.FactionAffinity
 import net.psforever.objects.vital.resistance.ResistanceProfile
 import net.psforever.objects.vital.{DamageResistanceModel, Vitality}
@@ -58,6 +58,8 @@ class Player(private val core : Avatar) extends PlanetSideGameObject
 
   Player.SuitSetup(this, exosuit)
 
+  def CharId : Long = core.CharId
+
   def Name : String = core.name
 
   def Faction : PlanetSideEmpire.Value = core.faction
@@ -294,7 +296,9 @@ class Player(private val core : Avatar) extends PlanetSideGameObject
 
   def RadiationShielding = exosuit.RadiationShielding
 
-  def LoadLoadout(line : Int) : Option[Loadout] = core.LoadLoadout(line)
+  def EquipmentLoadouts : LoadoutManager = core.EquipmentLoadouts
+
+  def SquadLoadouts : LoadoutManager = core.SquadLoadouts
 
   def BEP : Long = core.BEP
 
diff --git a/common/src/main/scala/net/psforever/objects/avatar/LoadoutManager.scala b/common/src/main/scala/net/psforever/objects/avatar/LoadoutManager.scala
new file mode 100644
index 00000000..c5978723
--- /dev/null
+++ b/common/src/main/scala/net/psforever/objects/avatar/LoadoutManager.scala
@@ -0,0 +1,27 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.objects.avatar
+
+import net.psforever.objects.loadouts.Loadout
+import net.psforever.types.LoadoutType
+
+import scala.util.Success
+
+class LoadoutManager(size : Int) {
+  private val entries : Array[Option[Loadout]] = Array.fill[Option[Loadout]](size)(None)
+
+  def SaveLoadout(owner : Any, label : String, line : Int) : Unit = {
+    Loadout.Create(owner, label) match {
+      case Success(loadout) =>
+        entries(line) = Some(loadout)
+      case _ => ;
+    }
+  }
+
+  def LoadLoadout(line : Int) : Option[Loadout] = entries.lift(line).flatten
+
+  def DeleteLoadout(line : Int) : Unit = {
+    entries(line) = None
+  }
+
+  def Loadouts : Seq[(Int, Loadout)] = entries.zipWithIndex.collect { case(Some(loadout), index) => (index, loadout) } toSeq
+}
diff --git a/common/src/main/scala/net/psforever/objects/definition/converter/AvatarConverter.scala b/common/src/main/scala/net/psforever/objects/definition/converter/AvatarConverter.scala
index a141529c..bbd9f1f5 100644
--- a/common/src/main/scala/net/psforever/objects/definition/converter/AvatarConverter.scala
+++ b/common/src/main/scala/net/psforever/objects/definition/converter/AvatarConverter.scala
@@ -81,7 +81,7 @@ object AvatarConverter {
       ),
       obj.ExoSuit,
       0,
-      0L,
+      obj.CharId,
       0,
       0,
       0,
diff --git a/common/src/main/scala/net/psforever/objects/loadouts/EquipmentLoadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/EquipmentLoadout.scala
new file mode 100644
index 00000000..53925f90
--- /dev/null
+++ b/common/src/main/scala/net/psforever/objects/loadouts/EquipmentLoadout.scala
@@ -0,0 +1,22 @@
+// Copyright (c) 2017 PSForever
+package net.psforever.objects.loadouts
+
+/**
+  * The base of all specific kinds of blueprint containers.
+  * This previous state can be restored on any appropriate template from which the loadout was copied
+  * by reconstructing any items (if warranted and permitted) or restoring any appropriate fields.
+  * The three fields are the name assigned to the loadout,
+  * the visible items that are created (which obey different rules depending on the source),
+  * and the concealed items that are created and added to the source's `Inventory`.<br>
+  * For example, the `visible_slots` on a `Player`-borne loadout will transform into the form `Array[EquipmentSlot]`;
+  * `Vehicle`-originating loadouts transform into the form `Map[Int, Equipment]`.
+  * <br>
+  * The lists of user-specific loadouts are initialized with `FavoritesMessage` packets.
+  * Specific entries are loaded or removed using `FavoritesRequest` packets.
+  * @param label the name by which this inventory will be known when displayed in a Favorites list
+  * @param visible_slots simplified representation of the `Equipment` that can see "seen" on the target
+  * @param inventory simplified representation of the `Equipment` in the target's inventory or trunk
+  */
+abstract class EquipmentLoadout(label : String,
+                                visible_slots : List[Loadout.SimplifiedEntry],
+                                inventory : List[Loadout.SimplifiedEntry]) extends Loadout(label)
diff --git a/common/src/main/scala/net/psforever/objects/loadouts/InfantryLoadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/InfantryLoadout.scala
index 0f9986e2..18c2f57f 100644
--- a/common/src/main/scala/net/psforever/objects/loadouts/InfantryLoadout.scala
+++ b/common/src/main/scala/net/psforever/objects/loadouts/InfantryLoadout.scala
@@ -28,7 +28,7 @@ final case class InfantryLoadout(label : String,
                                  visible_slots : List[Loadout.SimplifiedEntry],
                                  inventory : List[Loadout.SimplifiedEntry],
                                  exosuit : ExoSuitType.Value,
-                                 subtype : Int) extends Loadout(label, visible_slots, inventory)
+                                 subtype : Int) extends EquipmentLoadout(label, visible_slots, inventory)
 
 object InfantryLoadout {
   import net.psforever.objects.Player
diff --git a/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala
index 12e0cf41..58490f60 100644
--- a/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala
+++ b/common/src/main/scala/net/psforever/objects/loadouts/Loadout.scala
@@ -5,30 +5,29 @@ import net.psforever.objects._
 import net.psforever.objects.definition._
 import net.psforever.objects.equipment.{Equipment, EquipmentSlot}
 import net.psforever.objects.inventory.InventoryItem
+import net.psforever.objects.teamwork.Squad
 
 import scala.annotation.tailrec
+import scala.util.{Failure, Success, Try}
 
 /**
   * The base of all specific kinds of blueprint containers.
   * This previous state can be restored on any appropriate template from which the loadout was copied
-  * by reconstructing the items (if permitted).
-  * The three fields are the name assigned to the loadout,
-  * the visible items that are created (which obey different rules depending on the source),
-  * and the concealed items that are created and added to the source's `Inventory`.<br>
-  * For example, the `visible_slots` on a `Player`-borne loadout will transform into the form `Array[EquipmentSlot]`;
-  * `Vehicle`-originating loadouts transform into the form `Map[Int, Equipment]`.
-  * <br>
-  * The lists of user-specific loadouts are initialized with `FavoritesMessage` packets.
-  * Specific entries are loaded or removed using `FavoritesRequest` packets.
+  * by reconstructing any items (if warranted and permitted) or restoring any appropriate fields.
   * @param label the name by which this inventory will be known when displayed in a Favorites list
-  * @param visible_slots simplified representation of the `Equipment` that can see "seen" on the target
-  * @param inventory simplified representation of the `Equipment` in the target's inventory or trunk
   */
-abstract class Loadout(label : String,
-                       visible_slots : List[Loadout.SimplifiedEntry],
-                       inventory : List[Loadout.SimplifiedEntry])
+abstract class Loadout(label : String)
 
 object Loadout {
+  def Create(owner : Any, label : String) : Try[Loadout] = {
+    owner match {
+      case p : Player => Success(Create(p, label))
+      case v : Vehicle => Success(Create(v, label))
+      case s : Squad => Success(Create(s, label))
+      case _ => Failure(new MatchError(s"can not create a loadout based on the (current status of) $owner"))
+    }
+  }
+
   /**
     * Produce the blueprint on a player.
     * @param player the player
@@ -54,12 +53,32 @@ object Loadout {
   def Create(vehicle : Vehicle, label : String) : Loadout = {
     VehicleLoadout(
       label,
-      packageSimplifications(vehicle.Weapons.map({ case ((index, weapon)) => InventoryItem(weapon.Equipment.get, index) }).toList),
+      packageSimplifications(vehicle.Weapons.map({ case (index, weapon) => InventoryItem(weapon.Equipment.get, index) }).toList),
       packageSimplifications(vehicle.Trunk.Items),
       vehicle.Definition
     )
   }
 
+  /**
+    *  na
+    */
+  def Create(squad : Squad, label : String) : Loadout = {
+    SquadLoadout(
+      label,
+      squad.Task,
+      if(squad.CustomZoneId) { Some(squad.ZoneId) } else { None },
+      squad.Membership
+        .zipWithIndex
+        .filter { case (_, index) =>
+          squad.Availability(index)
+        }
+        .map {case (member, index) =>
+          SquadPositionLoadout(index, member.Role, member.Orders, member.Requirements)
+        }
+        .toList
+    )
+  }
+
   /**
     * A basic `Trait` connecting all of the `Equipment` blueprints.
     */
diff --git a/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala
new file mode 100644
index 00000000..9039c5a0
--- /dev/null
+++ b/common/src/main/scala/net/psforever/objects/loadouts/SquadLoadout.scala
@@ -0,0 +1,11 @@
+// Copyright (c) 2019 PSForever
+package net.psforever.objects.loadouts
+
+import net.psforever.types.CertificationType
+
+final case class SquadPositionLoadout(index : Int, role : String, orders : String, requirements : Set[CertificationType.Value])
+
+final case class SquadLoadout(label : String,
+                              task : String,
+                              zone_id : Option[Int],
+                              members : List[SquadPositionLoadout]) extends Loadout(label)
diff --git a/common/src/main/scala/net/psforever/objects/loadouts/VehicleLoadout.scala b/common/src/main/scala/net/psforever/objects/loadouts/VehicleLoadout.scala
index 5f7e0b63..c4199e0c 100644
--- a/common/src/main/scala/net/psforever/objects/loadouts/VehicleLoadout.scala
+++ b/common/src/main/scala/net/psforever/objects/loadouts/VehicleLoadout.scala
@@ -24,4 +24,4 @@ import net.psforever.objects.definition._
 final case class VehicleLoadout(label : String,
                                 visible_slots : List[Loadout.SimplifiedEntry],
                                 inventory : List[Loadout.SimplifiedEntry],
-                                vehicle_definition : VehicleDefinition) extends Loadout(label, visible_slots, inventory)
+                                vehicle_definition : VehicleDefinition) extends EquipmentLoadout(label, visible_slots, inventory)
diff --git a/common/src/main/scala/net/psforever/objects/serverobject/terminals/OrderTerminalDefinition.scala b/common/src/main/scala/net/psforever/objects/serverobject/terminals/OrderTerminalDefinition.scala
index 4784d8de..9c4e34d7 100644
--- a/common/src/main/scala/net/psforever/objects/serverobject/terminals/OrderTerminalDefinition.scala
+++ b/common/src/main/scala/net/psforever/objects/serverobject/terminals/OrderTerminalDefinition.scala
@@ -258,7 +258,7 @@ object OrderTerminalDefinition {
   //TODO block equipment by blocking ammunition type
   final case class InfantryLoadoutPage() extends LoadoutTab {
     override def Buy(player : Player, msg : ItemTransactionMessage) : Terminal.Exchange = {
-      player.LoadLoadout(msg.unk1) match {
+      player.EquipmentLoadouts.LoadLoadout(msg.unk1) match {
         case Some(loadout : InfantryLoadout) if !Exclude.contains(loadout.exosuit) && !Exclude.contains((loadout.exosuit, loadout.subtype)) =>
           val holsters = loadout.visible_slots
             .map(entry => { InventoryItem(BuildSimplifiedPattern(entry.item), entry.index) })
@@ -287,7 +287,7 @@ object OrderTerminalDefinition {
     */
   final case class VehicleLoadoutPage() extends LoadoutTab {
     override def Buy(player : Player, msg : ItemTransactionMessage) : Terminal.Exchange = {
-      player.LoadLoadout(msg.unk1 + 10) match {
+      player.EquipmentLoadouts.LoadLoadout(msg.unk1 + 10) match {
         case Some(loadout : VehicleLoadout) if !Exclude.contains(loadout.vehicle_definition) =>
           val weapons = loadout.visible_slots
             .map(entry => { InventoryItem(BuildSimplifiedPattern(entry.item), entry.index) })
diff --git a/common/src/main/scala/net/psforever/objects/teamwork/Member.scala b/common/src/main/scala/net/psforever/objects/teamwork/Member.scala
index 4d3b24e8..1ddfc46d 100644
--- a/common/src/main/scala/net/psforever/objects/teamwork/Member.scala
+++ b/common/src/main/scala/net/psforever/objects/teamwork/Member.scala
@@ -10,6 +10,7 @@ class Member {
   private var requirements : Set[CertificationType.Value] = Set()
   //about the individual filling the position
   private var name : String = ""
+  private var charId : Long = 0L
   private var health : Int = 0
   private var armor : Int = 0
   private var zoneId : Int = 0
@@ -43,6 +44,13 @@ class Member {
     Name
   }
 
+  def CharId : Long = charId
+
+  def CharId_=(id : Long) : Long = {
+    charId = id
+    CharId
+  }
+
   def Health : Int = health
 
   def Health_=(red : Int) : Int = {
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
index 43009a3b..7b9b4647 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDefinitionActionMessage.scala
@@ -366,7 +366,7 @@ object SquadDefinitionActionMessage extends Marshallable[SquadDefinitionActionMe
       case 2 | 6 | 9 | 11 |
            12 | 13 | 14 | 16 | 17 |
            18 | 29 | 30 | 32 | 33 |
-           36 | 37 | 38 | 42 | 43 => unknownCodec(code)
+           36 | 37 | 38 | 39 | 42 | 43 => unknownCodec(code)
       case _ => failureCodec(code)
     }).asInstanceOf[Codec[SquadAction]]
   }
diff --git a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
index 76fae022..98d6adef 100644
--- a/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
+++ b/common/src/main/scala/net/psforever/packet/game/SquadDetailDefinitionUpdateMessage.scala
@@ -1,6 +1,7 @@
 // Copyright (c) 2019 PSForever
 package net.psforever.packet.game
 
+import net.psforever.packet.game.SquadDetailDefinitionUpdateMessage.defaultRequirements
 import net.psforever.packet.{GamePacketOpcode, Marshallable, PacketHelpers, PlanetSideGamePacket}
 import net.psforever.types.CertificationType
 import scodec.bits.BitVector
@@ -18,7 +19,9 @@ final case class SquadPositionDetail(is_closed : Boolean,
                                      name : String)
 
 final case class SquadDetailDefinitionUpdateMessage(guid : PlanetSideGUID,
-                                                    unk : BitVector,
+                                                    unk1 : Int,
+                                                    leader_char_id : Long,
+                                                    unk2 : BitVector,
                                                     leader_name : String,
                                                     task : String,
                                                     zone_id : PlanetSideZoneID,
@@ -32,27 +35,17 @@ final case class SquadDetailDefinitionUpdateMessage(guid : PlanetSideGUID,
 object SquadPositionDetail {
   final val Closed : SquadPositionDetail = SquadPositionDetail(is_closed = true, "", "", Set.empty, 0L, "")
 
-  private def reliableNameHash(name : String) : Long = {
-    val hash = name.hashCode.toLong
-    if(hash < 0) {
-      -1L * hash
-    }
-    else {
-      hash
-    }
-  }
-
   def apply() : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, 0L, "")
 
-  def apply(name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, reliableNameHash(name), name)
+  def apply(char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, "", "", Set.empty, char_id, name)
 
   def apply(role : String, detailed_orders : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, 0L, "")
 
   def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value]) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, 0L, "")
 
-  def apply(role : String, detailed_orders : String, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, reliableNameHash(name), name)
+  def apply(role : String, detailed_orders : String, char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, Set.empty, char_id, name)
 
-  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, reliableNameHash(name), name)
+  def apply(role : String, detailed_orders : String, requirements : Set[CertificationType.Value], char_id : Long, name : String) : SquadPositionDetail = SquadPositionDetail(is_closed = false, role, detailed_orders, requirements, char_id, name)
 }
 
 object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefinitionUpdateMessage] {
@@ -64,6 +57,7 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
 
   final val Init = SquadDetailDefinitionUpdateMessage(
     PlanetSideGUID(0),
+    0L,
     "",
     "",
     PlanetSideZoneID(0),
@@ -81,9 +75,9 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
     )
   )
 
-  def apply(guid : PlanetSideGUID, leader_name : String, task : String, zone_id : PlanetSideZoneID, member_info : List[SquadPositionDetail]) : SquadDetailDefinitionUpdateMessage = {
+  def apply(guid : PlanetSideGUID, char_id : Long, leader_name : String, task : String, zone_id : PlanetSideZoneID, member_info : List[SquadPositionDetail]) : SquadDetailDefinitionUpdateMessage = {
     import scodec.bits._
-    SquadDetailDefinitionUpdateMessage(guid, hex"080000000000000000000".toBitVector, leader_name, task, zone_id, member_info)
+    SquadDetailDefinitionUpdateMessage(guid, 1, char_id, hex"000000".toBitVector, leader_name, task, zone_id, member_info)
   }
 
   private def memberCodec(pad : Int) : Codec[SquadPositionDetail] = {
@@ -191,9 +185,14 @@ object SquadDetailDefinitionUpdateMessage extends Marshallable[SquadDetailDefini
     import shapeless.::
     (
       ("guid" | PlanetSideGUID.codec) ::
-        uint8 ::
-        uint4 ::
-        bits(83) :: //variable fields, but can be 0'd
+        uint4 :: //constant = 8
+        uint4 :: //variable = 0-4
+        bool :: //true, when 4
+        uint4 :: //variable = 0-12?
+        ("unk1" | uint4) ::
+        uint24 :: //unknown, but can be 0'd
+        ("leader_char_id" | uint32L) ::
+        ("unk2" | bits(22)) :: //variable fields, but can be 0'd
         uint(10) :: //constant = 0
         ("leader" | PacketHelpers.encodedWideStringAligned(7)) ::
         ("task" | PacketHelpers.encodedWideString) ::
